CC_Vars = {
	visible = true,
	bvis = true,
	enabled = true,
	locked = true,
	alpha = 1,
	messages = true,
	total = 0,
	current = 0,
	gained = 0,
	lost = 0
};

CC_Strings = {
	total = "Even spent/earned",
	gained = "",
	lost = ""
};

function CC_OnLoad(self)
	SLASH_CASHCOUNTER1 = "/cashcounter";
	SLASH_CASHCOUNTER2 = "/cc";
	SlashCmdList["CASHCOUNTER"] = CC_SlashCommand;
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_MONEY");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function CC_SlashCommand(msg)
	msg = string.lower(msg);
	local args = {};
	for word in string.gmatch(msg, "[^%s]+") do
		table.insert(args, word);
	end
	if ( args[1] ) then
		if ( args[1] == "lock" ) then
			CC_Vars.locked = true;

		elseif ( args[1] == "unlock" ) then
			CC_Vars.locked = false;
			
		elseif ( args[1] == "enable" or args[1] == "disable") then
			CC_Enable(args[1]);
			
		elseif ( args[1] == "show" or args[1] == "hide") then
			CC_Toggle(args[1]);

		elseif ( args[1] == "alpha" ) then
			local alpha = tonumber(args[2])
			if ( alpha and alpha >= 0 and alpha <= 1 ) then
				CC_Vars.alpha = alpha;
				CC_Title:SetAlpha(alpha);
			else
				CC_Message(CASHCOUNTER_ALPHAWRONG);
			end
			
		elseif ( args[1] == "messages" ) then
			CC_Vars.messages = not CC_Vars.messages;
			
		elseif ( args[1] == "reset" ) then
			if ( args[2] and args[2] == "all" ) then
				CC_Reset();
				CC_Reset_All();
			else
				CC_Reset()
			end
		else
			CC_Message(CASHCOUNTER_NOCOMMAND);
		end
	else
		CC_Message(CASHCOUNTER_USAGE);
		CC_Message("lock - "..CASHCOUNTER_LOCK);
		CC_Message("unlock - "..CASHCOUNTER_UNLOCK);
		CC_Message("show - "..CASHCOUNTER_SHOW);
		CC_Message("hide - "..CASHCOUNTER_HIDE);
		CC_Message("enable - "..CASHCOUNTER_ENABLE);
		CC_Message("disable - "..CASHCOUNTER_DISABLE);
		CC_Message("alpha <#> - "..CASHCOUNTER_ALPHA);
		CC_Message("messages - "..CASHCOUNTER_MESSAGES);
		CC_Message("reset/reset all - "..CASHCOUNTER_RESET);
	end
end

function CC_Message(msg)
	if ( CC_Vars.messages == true ) then
		DEFAULT_CHAT_FRAME:AddMessage("[CashCounter]: "..msg);
	end
end

function CC_Toggle(arg)
	if ( arg == "hide" ) then
		CC_Vars.visible = false;
		CC_Title:Hide();
		CC_Message(CASHCOUNTER_HIDDEN);
	else
		CC_Vars.visible = true;
		CC_Title:Show();
		CC_Message(CASHCOUNTER_VISIBLE);
	end
end

function CC_Enable(arg)
	if ( arg == "disable" ) then
		CC_Vars.enabled = false;
		CC_Message(CASHCOUNTER_DISABLED);
	else
		CC_Vars.enabled = true;
		CC_Message(CASHCOUNTER_ENABLED);
	end
end

function CC_Reset()
	CC_Vars.total = 0;
	CC_Vars.current = GetMoney();
	CC_Vars.gained = 0;
	CC_Vars.lost = 0;
	
	getCash();
	if ( CC_Vars.total > 0 ) then
		CC_Strings.total = "Total Earned : "..formatCash(CC_Vars.total);
	elseif ( CC_Vars.total < 0 ) then			
		CC_Strings.total = "Total Lost : "..formatCash(CC_Vars.total);
	else
		CC_Strings.total = "Even spent/earned";
	end
	CC_Strings.gained = "Earned: "..formatCash(CC_Vars.gained);
	CC_Strings.lost = "Spent: "..formatCash(CC_Vars.lost);
	setText();
end

function CC_Reset_All()
	CC_Vars.visible = true;
	CC_Vars.bvis = true;
	CC_Vars.enabled = true;
	CC_Vars.locked = true;
	CC_Vars.alpha = 1;
	CC_Vars.messages = true;
	
	CC_Title:ClearAllPoints();
	CC_Title:SetPoint("TOP","UIParent","TOP");
	CC_Vars.locked = true;
	
	CC_Title:SetAlpha(CC_Vars.alpha);
	CC_Title_LockButton:SetChecked(CC_Vars.locked);
	
	CC_Title:Show();
	CC_Frame:Show();
	CC_Title_LockButton:Show();
	setText();
end

function CC_OnEvent(self, event, ...)
    if ( event == "VARIABLES_LOADED" ) then
		if ( CC_Vars.total == 0 ) then
			CC_Reset_Frame:Hide();
		end
	
		CC_Title:SetAlpha(CC_Vars.alpha);
		CC_Title_LockButton:SetChecked(CC_Vars.locked);
		
		if ( CC_Vars.visible == false ) then
			CC_Title:Hide();
		else
			CC_Title:Show();
		end
		
		if ( CC_Vars.bvis == false ) then
			CC_Frame:Hide();
			CC_Title_LockButton:Hide();
		else
			CC_Frame:Show();
			CC_Title_LockButton:Show();
		end
		getCash();
		if ( CC_Vars.total > 0 ) then
			CC_Strings.total = "Total Earned : "..formatCash(CC_Vars.total);
		elseif ( CC_Vars.total < 0 ) then
			CC_Strings.total = "Total Lost : "..formatCash(CC_Vars.total);
		else
			CC_Strings.total = "Even spent/earned";
		end
		CC_Strings.gained = "Earned: "..formatCash(CC_Vars.gained);
		CC_Strings.lost = "Spent: "..formatCash(CC_Vars.lost);
		setText();
		
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		CC_Vars.current = GetMoney();
		
    elseif ( event == "PLAYER_MONEY" ) then
		if ( CC_Vars.enabled == true ) then
			getCash();
			if ( CC_Vars.total > 0 ) then
				CC_Strings.total = "Total Earned : "..formatCash(CC_Vars.total);
			elseif ( CC_Vars.total < 0 ) then
				CC_Strings.total = "Total Lost : "..formatCash(CC_Vars.total);
			else
				CC_Strings.total = "Even spent/earned";
			end
			CC_Strings.gained = "Earned: "..formatCash(CC_Vars.gained);
			CC_Strings.lost = "Spent: "..formatCash(CC_Vars.lost);
			setText();
		end
	end
end

function formatCash(amount)
	local gold = floor(abs(amount / 10000));
	local silver = floor(abs(mod(amount / 100, 100)));
	local copper = floor(abs(mod(amount,100)));
	return gold.."g "..silver.."s "..copper.."c";
end

function getCash()
	CC_Vars.total = CC_Vars.total + (GetMoney() - CC_Vars.current);
	if ( GetMoney() < CC_Vars.current ) then
		CC_Vars.lost = CC_Vars.lost + (CC_Vars.current - GetMoney());
	elseif ( GetMoney() > CC_Vars.current ) then
		CC_Vars.gained = CC_Vars.gained + (GetMoney() - CC_Vars.current);
	end
	CC_Vars.current = GetMoney();
end

function setText()
	if ( CC_Vars.bvis == true ) then
		CC_Frame_Total:SetText(CC_Strings.total);
		CC_Frame_Gained:SetText(CC_Strings.gained);
		CC_Frame_Lost:SetText(CC_Strings.lost);
		CC_Title_Text:SetText(CASHCOUNTER_TITLE);
	else
		CC_Title_Text:SetText(CC_Strings.total);
	end
end

function CC_OnEnter(self)
	GameTooltip_SetDefaultAnchor(GameTooltip, self);
	GameTooltip:SetText(CASHCOUNTER_TITLE);
	if ( CC_Vars.enabled == false ) then
		GameTooltip:AddLine(CASHCOUNTER_DISABLED);
	else
		GameTooltip:AddLine(CASHCOUNTER_ENABLED);
	end
	if ( CC_Vars.locked ) then
		GameTooltip:AddLine(CASHCOUNTER_LOCKED);
	else
		GameTooltip:AddLine(CASHCOUNTER_LEFTCLICK);
	end
	GameTooltip:AddLine(CASHCOUNTER_RIGHTCLICK);
	if ( CC_Vars.messages == true ) then
		GameTooltip:AddLine(CASHCOUNTER_OPTIONS);
	else
		GameTooltip:AddLine(CASHCOUNTER_MESSAGES_DISABLED);
	end
	GameTooltipTextLeft1:SetTextColor(1, 1, 1);
	GameTooltip:Show();
end

function CCLock_OnEnter(self)
	GameTooltip:SetOwner(CC_Title_LockButton, "ANCHOR_Right");
	if ( CC_Vars.locked ) then
		GameTooltip:AddLine(CASHCOUNTER_LOCKED);
		GameTooltip:AddLine(CASHCOUNTER_UNLOCK);
	else
		GameTooltip:AddLine(CASHCOUNTER_LEFTCLICK);
		GameTooltip:AddLine(CASHCOUNTER_LOCK);
	end
	GameTooltipTextLeft1:SetTextColor(1, 1, 1);
	GameTooltip:Show();
end

function CC_MouseDown(self, button)
	if ( button == "LeftButton" and CC_Vars.locked == false ) then
		self:StartMoving();
		self.isMoving = true;
	elseif ( button == "RightButton" and CC_Frame:IsShown() ) then
		CC_Frame:Hide();
		CC_Title_LockButton:Hide();
		CC_Vars.bvis = false;
		setText();
	elseif ( button == "RightButton" ) then
		CC_Frame:Show();
		CC_Title_LockButton:Show();
		CC_Vars.bvis = true;
		setText();
	end
end